
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>基于微服务和Docker容器技术的PaaS云平台架构设计 / iVAN</title>

    <meta name="description" content="基于微服务和Docker容器技术的PaaS云平台架构设计 本文讲的是基于微服务和Docker容器技术的PaaS云平台架构设计[编者的话]在系统架构上,PaaS云平台主要分为微服务架构.Docker容器技术.DveOps三部分,这篇文章重点介绍微服务架构的实施. [3 天烧脑式容器存储网络训练营 | 深圳站]本次培训以容器存储和网络为主题,包括:Docker Plugin.Docker storage driver.Docker Volume Pulgin.Kubernetes Storage机制.容器网络实现原理和模型.Docker网络实现.网络插件.">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">基于微服务和Docker容器技术的PaaS云平台架构设计</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<p>本文讲的是<b>基于微服务和Docker容器技术的PaaS云平台架构设计</b>【编者的话】在系统架构上，PaaS云平台主要分为微服务架构、Docker容器技术、DveOps三部分，这篇文章重点介绍微服务架构的实施。</p>
<p><em><a href="http://dockone.io/article/2445" rel="external nofollow noreferrer">【3 天烧脑式容器存储网络训练营 | 深圳站】本次培训以容器存储和网络为主题，包括：Docker Plugin、Docker storage driver、Docker Volume Pulgin、Kubernetes Storage机制、容器网络实现原理和模型、Docker网络实现、网络插件、Calico、Contiv Netplugin、开源企业级镜像仓库Harbor原理及实现等。</a></em></p>
<p>基于微服务架构和Docker容器技术的PaaS云平台建设目标是给我们的开发人员提供一套服务快速开发、部署、运维管理、持续开发持续集成的流程。平台提供基础设施、中间件、数据服务、云服务器等资源，开发人员只需要开发业务代码并提交到平台代码库，做一些必要的配置，系统会自动构建、部署，实现应用的敏捷开发、快速迭代。在系统架构上，PaaS云平台主要分为微服务架构、Docker容器技术、DveOps三部分，这篇文章重点介绍微服务架构的实施。</p>
<p>实施微服务需要投入大量的技术力量来开发基础设施，这对很多公司来说显然是不现实的，别担心，业界已经有非常优秀的开源框架供我们参考使用。目前业界比较成熟的微服务框架有Netflix、Spring Cloud和阿里的Dubbo等。Spring Cloud是基于Spring Boot的一整套实现微服务的框架，它提供了开发微服务所需的组件，跟Spring Boot一起使用的话开发微服务架构的云服务会变的很方便。Spring Cloud包含很多子框架，其中Spring Cloud Netflix是其中的一套框架，在我们的微服务架构设计中，就使用了很多Spring Cloud Netflix框架的组件。Spring Cloud Netflix项目的时间还不长，相关的文档资料很少，博主当时研究这套框架啃了很多英文文档，简直痛苦不堪。对于刚开始接触这套框架的同学，要搭建一套微服务应用架构，可能会不知道如何下手，接下来介绍我们的微服务架构搭建过程以及需要那些框架或组件来支持微服务架构。</p>
<p>为了直接明了的展示微服务架构的组成及原理，博主画了一张系统架构图，如下：</p>
<p><a href="http://dockerone.com/uploads/article/20170626/8d7c74ae6f8d0da7fdc7c340d49c3577.jpg" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvZG9ja2Vyb25lLmNvbS91cGxvYWRzL2FydGljbGUvMjAxNzA2MjYvOGQ3Yzc0YWU2ZjhkMGRhN2ZkYzdjMzQwZDQ5YzM1NzcuanBn.jpg"></a></p>
<p>从上图可以看出，微服务访问大致路径为：外部请求 → 负载均衡 → 服务网关（GateWay）→ 微服务 → 数据服务/消息服务。服务网关和微服务都会用到服务注册和发现来调用依赖的其他服务，各服务集群都能通过配置中心服务来获得配置信息。<br />
<h3>服务网关（GateWay）</h3>
<p>网关是外界系统（如：客户端浏览器、移动设备等）和企业内部系统之间的一道门，所有的客户端请求通过网关访问后台服务。为了应对高并发访问，服务网关以集群形式部署，这就意味着需要做负载均衡，我们采用了亚马逊EC2作为虚拟云服务器，采用ELB（Elastic Load Balancing）做负载均衡。EC2具有自动配置容量功能，当用户流量达到尖峰，EC2可以自动增加更多的容量以维持虚拟主机的性能。ELB弹性负载均衡，在多个实例间自动分配应用的传入流量。为了保证安全性，客户端请求需要使用https加密保护，这就需要我们进行SSL卸载,使用Nginx对加密请求进行卸载处理。外部请求经过ELB负载均衡后路由到GateWay集群中的某个GateWay服务，由GateWay服务转发到微服务。服务网关作为内部系统的边界，它有以下基本能力：
<ol>
<li>动态路由：动态的将请求路由到所需要的后端服务集群。虽然内部是复杂的分布式微服务网状结构，但是外部系统从网关看就像是一个整体服务，网关屏蔽了后端服务的复杂性。</li>
<li>限流和容错：为每种类型的请求分配容量，当请求数量超过阀值时抛掉外部请求，限制流量，保护后台服务不被大流量冲垮；党内部服务出现故障时直接在边界创建一些响应，集中做容错处理，而不是将请求转发到内部集群，保证用户良好的体验。</li>
<li>身份认证和安全性控制：对每个外部请求进行用户认证，拒绝没有通过认证的请求，还能通过访问模式分析，实现反爬虫功能。</li>
<li>监控：网关可以收集有意义的数据和统计，为后台服务优化提供数据支持。</li>
<li>访问日志：网关可以收集访问日志信息，比如访问的是哪个服务？处理过程（出现什么异常）和结果？花费多少时间？通过分析日志内容，对后台系统做进一步优化。</li>
</ol>
<p>我们采用Spring Cloud Netflix框架的开源组件Zuul来实现网关服务。Zuul使用一系列不同类型的过滤器（Filter），通过重写过滤器，使我们能够灵活的实现网关（GateWay）的各种功能。<br />
<h3>服务注册与发现</h3>
<p>由于微服务架构是由一系列职责单一的细粒度服务构成的网状结构，服务之间通过轻量机制进行通信，这就引入了服务注册与发现的问题，服务的提供方要注册报告服务地址，服务调用放要能发现目标服务。我们的微服务架构中使用了Eureka组件来实现服务的注册与发现。所有的微服务（通过配置Eureka服务信息）到Eureka服务器中进行注册，并定时发送心跳进行健康检查，Eureka默认配置是30秒发送一次心跳，表明服务仍然处于存活状态，发送心跳的时间间隔可以通过Eureka的配置参数自行配置，Eureka服务器在接收到服务实例的最后一次心跳后，需要等待90秒（默认配置90秒，可以通过配置参数进行修改）后，才认定服务已经死亡（即连续3次没有接收到心跳），在Eureka自我保护模式关闭的情况下会清除该服务的注册信息。所谓的自我保护模式是指，出现网络分区、Eureka在短时间内丢失过多的服务时，会进入自我保护模式，即一个服务长时间没有发送心跳，Eureka也不会将其删除。自我保护模式默认为开启，可以通过配置参数将其设置为关闭状态。</p>
<p>Eureka服务以集群的方式部署（在博主的另一篇文章中详细介绍了<a href="http://www.cnblogs.com/fangfuhai/p/6102486.html" rel="external nofollow noreferrer">Eureka集群的部署方式</a>），集群内的所有Eureka节点会定时自动同步微服务的注册信息，这样就能保证所有的Eureka服务注册信息保持一致。那么在Eureka集群里，Eureka节点是如何发现其他节点的呢？我们通过DNS服务器来建立所有Eureka节点的关联，在部署Eureka集群之外还需要搭建DNS服务器。</p>
<p>当网关服务转发外部请求或者是后台微服务之间相互调用时，会去Eureka服务器上查找目标服务的注册信息，发现目标服务并进行调用，这样就形成了服务注册与发现的整个流程。Eureka的配置参数数量很多，多达上百个，博主会在另外的文章里详细说明。<br />
<h3>微服务部署</h3>
<p>微服务是一系列职责单一、细粒度的服务，是将我们的业务进行拆分为独立的服务单元，伸缩性好，耦合度低，不同的微服务可以用不同的语言开发，每一个服务处理的单一的业务。微服务可以划分为前端服务（也叫边缘服务）和后端服务（也叫中间服务），前端服务是对后端服务做必要的聚合和剪裁后暴露给外部不同的设备（PC、Phone等），所有的服务启动时都会到Eureka服务器进行注册，服务之间会有错综复杂的依赖关系。当网关服务转发外部请求调用前端服务时，通过查询服务注册表就可以发现目标服务进行调用，前端服务调用后端服务时也是同样的道理，一次请求可能涉及到多个服务之间的相互调用。由于每个微服务都是以集群的形式部署，服务之间相互调用的时候需要做负载均衡，因此每个服务中都有一个LB组件用来实现负载均衡。</p>
<p>微服务以镜像的形式，运行在Docker容器中。Docker容器技术让我们的服务部署变得简单、高效。传统的部署方式，需要在每台服务器上安装运行环境，如果我们的服务器数量庞大，在每台服务器上安装运行环境将是一项无比繁重的工作，一旦运行环境发生改变，就不得不重新安装，这简直是灾难性的。而使用Docker容器技术，我们只需要将所需的基础镜像（jdk等）和微服务生成一个新的镜像，将这个最终的镜像部署在Docker容器中运行，这种方式简单、高效，能够快速部署服务。每个Docker容器中可以运行多个微服务，Docker容器以集群的方式部署，使用Docker Swarm对这些容器进行管理。我们创建一个镜像仓库用来存放所有的基础镜像以及生成的最终交付镜像，在镜像仓库中对所有镜像进行管理。<br />
<h3>服务容错</h3>
<p>微服务之间存在错综复杂的依赖关系，一次请求可能会依赖多个后端服务，在实际生产中这些服务可能会产生故障或者延迟，在一个高流量的系统中，一旦某个服务产生延迟，可能会在短时间内耗尽系统资源，将整个系统拖垮，因此一个服务如果不能对其故障进行隔离和容错，这本身就是灾难性的。我们的微服务架构中使用了Hystrix组件来进行容错处理。Hystrix是Netflix的一款开源组件，它通过熔断模式、隔离模式、回退（fallback）和限流等机制对服务进行弹性容错保护，保证系统的稳定性。
<ol>
<li>熔断模式：熔断模式原理类似于电路熔断器，当电路发生短路时，熔断器熔断，保护电路避免遭受灾难性损失。当服务异常或者大量延时，满足熔断条件时服务调用方会主动启动熔断，执行fallback逻辑直接返回，不会继续调用服务进一步拖垮系统。熔断器默认配置服务调用错误率阀值为50%，超过阀值将自动启动熔断模式。服务隔离一段时间以后，熔断器会进入半熔断状态，即允许少量请求进行尝试，如果仍然调用失败，则回到熔断状态，如果调用成功，则关闭熔断模式。</li>
<li>隔离模式：Hystrix默认采用线程隔离，不同的服务使用不同的线程池，彼此之间不受影响，当一个服务出现故障耗尽它的线程池资源，其他的服务正常运行不受影响，达到隔离的效果。例如我们通过andThreadPoolKey配置某个服务使用命名为TestThreadPool的线程池，实现与其他命名的线程池隔离。</li>
<li>回退（fallback）：fallback机制其实是一种服务故障时的容错方式，原理类似Java中的异常处理。只需要继承HystixCommand并重写getFallBack()方法，在此方法中编写处理逻辑，比如可以直接抛异常（快速失败），可以返回空值或缺省值，也可以返回备份数据等。当服务调用出现异常时，会转向执行getFallBack()。有以下几种情况会触发fallback：
<ol>
<li>程序抛出非HystrixBadRequestExcepption异常，当抛出HystrixBadRequestExcepption异常时，调用程序可以捕获异常，没有触发fallback，当抛出其他异常时，会触发fallback；</li>
<li>程序运行超时；</li>
<li>熔断启动；</li>
<li>线程池已满。</li>
</ol>
</li>
<li>限流： 限流是指对服务的并发访问量进行限制，设置单位时间内的并发数，超出限制的请求拒绝并fallback，防止后台服务被冲垮。</li>
</ol>
<p>Hystix使用命令模式HystrixCommand包装依赖调用逻辑，这样相关的调用就自动处于Hystrix的弹性容错保护之下。调用程序需要继承HystrixCommand并将调用逻辑写在run()中，使用execute()（同步阻塞）或queue()（异步非阻塞）来触发执行run()。<br />
<h3>动态配置中心</h3>
<p>微服务有很多依赖配置，某些配置参数在服务运行期间可能还要动态修改，比如：根据访问流量动态调整熔断阀值。传统的实现信息配置的方法，比如放在xml、yml等配置文件中，和应用一起打包，每次修改都要重新提交代码、打包构建、生成新的镜像、重新启动服务，效率太低，这样显然是不合理的，因此我们需要搭建一个动态配置中心服务支持微服务动态配置。我们使用Spring Cloud的configserver服务帮我们实现动态配置中心的搭建。我们开发的微服务代码都存放在git服务器私有仓库里面，所有需要动态配置的配置文件存放在git服务器下的configserver（配置中心，也是一个微服务）服务中，部署到Docker容器中的微服务从git服务器动态读取配置文件的信息。当本地git仓库修改代码后push到git服务器仓库，git服务端hooks(post-receive，在服务端完成代码更新后会自动调用)自动检测是否有配置文件更新，如果有，git服务端通过消息队列给配置中心（configserver，一个部署在容器中的微服务）发消息，通知配置中心刷新对应的配置文件。这样微服务就能获取到最新的配置文件信息，实现动态配置。</p>
<p>以上这些框架或组件是支撑实施微服务架构的核心，在实际生产中，我们还会用到很多其他的组件，比如日志服务组件、消息服务组件等等，根据业务需要自行选择使用。在我们的微服务架构实施案例中，参考使用了很多Spring Cloud Netflix框架的开源组件，主要包括Zuul（服务网关）、Eureka（服务注册与发现）、Hystrix（服务容错）、Ribbon（客户端负载均衡）等。这些优秀的开源组件，为我们实施微服务架构提供了捷径。</p>
<p>以上篇幅主要介绍了微服务架构的基本原理，其中有些比较细节的东西，比如Eureka的各项参数配置说明、动态配置中心搭建过程等，博主会在其他的文章中做出详细的说明，供大家参考。</p>
<p>原文链接：<a href="http://www.cnblogs.com/fangfuhai/p/7065847.html" rel="external nofollow noreferrer">微服务架构：基于微服务和Docker容器技术的PaaS云平台架构设计（微服务架构实施原理）</a>（作者：方福海）</p>
<p><b>原文发布时间为：</b>2017-06-26</p>
<p><b>本文作者：</b>方福海</p>
<p><b></b></p>
<p><b>原文标题：</b><b>基于微服务和Docker容器技术的PaaS云平台架构设计</b></p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-03-29 22:06:43</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.iamivan.net/tag/%e6%9e%b6%e6%9e%84/" title="架构">架构</a>, <a href="https://www.iamivan.net/tag/%e6%9c%8d%e5%8a%a1%e5%99%a8/" title="服务器">服务器</a>, <a href="https://www.iamivan.net/tag/%e4%ba%91%e5%b9%b3%e5%8f%b0/" title="云平台">云平台</a>, <a href="https://www.iamivan.net/tag/%e9%9b%86%e7%be%a4/" title="集群">集群</a>, <a href="https://www.iamivan.net/tag/%e9%95%9c%e5%83%8f/" title="镜像">镜像</a>, <a href="https://www.iamivan.net/tag/%e8%b4%9f%e8%bd%bd%e5%9d%87%e8%a1%a1/" title="负载均衡">负载均衡</a>, <a href="https://www.iamivan.net/tag/%e9%85%8d%e7%bd%ae/" title="配置">配置</a>, <a href="https://www.iamivan.net/tag/%e7%ba%bf%e7%a8%8b/" title="线程">线程</a>, <a href="https://www.iamivan.net/tag/%e5%ae%b9%e5%99%a8/" title="容器">容器</a>, <a href="https://www.iamivan.net/tag/docker/" title="docker">docker</a>, <a href="https://www.iamivan.net/tag/%e5%be%ae%e6%9c%8d%e5%8a%a1/" title="微服务">微服务</a>, <a href="https://www.iamivan.net/tag/cloud/" title="Cloud">Cloud</a>, <a href="https://www.iamivan.net/tag/spring/" title="spring">spring</a>, <a href="https://www.iamivan.net/tag/paas/" title="paas">paas</a>, <a href="https://www.iamivan.net/tag/%e8%87%aa%e6%88%91%e4%bf%9d%e6%8a%a4/" title="自我保护">自我保护</a>        </div> -->
	</section>
	
	

		<div id="similar">

		<h3>基于微服务和Docker容器技术的PaaS云平台架构设计的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/b3YRZWp.html" rel="bookmark">基于MongoDB的高并发高可用政府云平台架构实践</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				3月12日下午在阿里巴巴西溪园区,举行了MongoDB杭州用户交流会.微软MSDN特邀讲师徐雷分享&lt;基于MongoDB的政府云平台高并发高可用HA架构实践 &gt;,从自身实践出发,讲述了政府云平台分层.技术栈选型.物理架构.API架构及DB数据库架构的设计思路和方法.   以下内容根据现场分享和演讲PPT整理而成.   学习MongoDB的重要性 目前,几乎所有国内外的互联网大公司都在用MongoDB,学习企业需要的技术很重要.   MongoDB优点   相比较关系型数据库而言,MongDB有两			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/M9Ey2VM.html" rel="bookmark">Spring Boot与Docker（四）：额外的微服务、更新容器、Docker Compose和负载均衡</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本文讲的是Spring Boot与Docker(四):额外的微服务.更新容器.Docker Compose和负载均衡,[编者的话]本篇是&lt;使用Spring Boot和Docker构建微服务架构&gt;系列的第四篇,本篇我们我们将添加一些额外的服务/容器,并且更新容器,采用Docker Compose以及使用HAProxy容器进行负载均衡.原文作者为3Pillar环球旗下美国Adbanced技术集团的总监Dan Greene,Dan有十八年的软件设计和开发经验,包括在电子商务.B2B集成.空间分析.S			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bBZOVdb.html" rel="bookmark">基于微服务架构，实解容器级DevOps平台的建设</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				导读:本文以&quot;实践过程中问题与思考&quot;为主体,与大家分享其中的过程和经验,希望大家在后续的工作中能够避免相关问题,形成更佳实践. 首先简单说下我们要做什么,不谈理念,不谈哲学,我们要做一款基于微服务架构,可以同时运行在公有云和私有云上的容器云平台,以DevOps为目标,提升协作效率,快速交付. 为什么选择阿里云 现在的公有云如雨后春笋,国外如AWS.Azure.Bluemix,国内如阿里云.腾讯云.DaoCloud.goodrain等,都可以给大家提供丰富的云基础设施和上层服务,那为什么			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zePraOp.html" rel="bookmark">Spring Boot与Docker（三）：构建你的第一个微服务和相关容器以及容器的连接</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本文讲的是Spring Boot与Docker(三):构建你的第一个微服务和相关容器以及容器的连接,[编者的话]本篇是&lt;使用Spring Boot和Docker构建微服务架构&gt;系列的第三篇,本篇我们将会准备开始构建一个员工对象微服务.原文作者为3Pillar环球旗下美国Adbanced技术集团的总监Dan Greene,Dan有十八年的软件设计和开发经验,包括在电子商务.B2B集成.空间分析.SOA架构.大数据以及云计算等领域的软件产品架构经验,他是AWS认证解决方案架构师,在3Pillar之			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/Mq7Ok3z.html" rel="bookmark">基于微服务API级权限的技术架构</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				一般而言,企业内部一套成熟的权限系统,都是基于角色(Role)的 访问控制方法(RBAC – Role Based Access Control),即权限 (Permission)与角色相关联,用户(User)通过成为适当角色的成员而得到这 些角色的权限,权限包含资源(或者与操作组合方式相结合),最终实现权限控制 的目的. 背景 权限系统是根据系统设置的安全规则或者安全策略,用户可以访问而且只能访问自己被授权的资源. 一般而言,企业内部一套成熟的权限系统,都是基于角色(Role)的访问控制方法(			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zVwe2Kb.html" rel="bookmark">微服务和 Docker 为什么变得如此重要呢？</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				[原文编者的话] 本文主要讲述Docker和微服务的发展,以及Cisco对于Docker和微服务的看法.最后还提到了Docker的libnetwork,以及Cisco的开源项目Contiv,Contiv是一种通用型网络插件,用来处理多主机系统容器集群网络的使用. 在过去的18个月里,我们见证了应用程序构建.打包.传送.部署和实例化方式的快速转变.这种变化的驱动力来源于开发人员对于简化开放方式的需求以 及着眼于以应用为中心的IT视角的转变.通过飞速发展的Docker以及基于体系结构来运行应用程序的			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pXw05lM.html" rel="bookmark">中间件和微服务，Docker以及原生云架构的关系</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				微服务和Docker的发展势头 微服务和容器的主要目标是缩短软件开发时间,以及实现开发.部署以及运维的更大灵活性.为什么它过去几个月的发展势头这么猛?因为几乎所有科技巨头企业如亚马逊,谷歌,Facebook,Netflix都在这里激烈竞争. 微服务就像是一个面向服务的架构(SOA):这是一种架构和供应商技术分别独立的设计理念.因此,目前并没有明确的界定标准或规范.你永远需要在和其他人讨论之前定义你所理解的微服务术语.每个人都有不同的定义.在这篇文章中微服务是被开发,部署和独立缩放的服务.它们可以			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bQrRDOM.html" rel="bookmark">你还不造吗？Docker容器技术5大窍门！</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Docker自从去年走到聚光灯下后,其粉丝基数就一直在增长.想要了解为什么,以及想从你的容器中获得更多,以下主要回顾了2015年Docker容器的五大窍门.2014年Docker复兴了容器技术,并在过去的一年里主导了整个容器市场.容器的便携性和可扩展性在云用户和开发人员那里得到了共鸣,并随着应用的增长,Docker不断地针对企业用户扩展其自身功能.尽管竞争对手争相提供类似服务,但Docker已经成为一个家喻户晓的名字.不过,一些企业仍然不确定他们是否应该采用容器以及如何将容器集成到他们的云环境中			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/Mq79XGz.html" rel="bookmark">这些Docker容器技术窍门你都知道吗？</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Docker自从去年走到聚光灯下后,其粉丝基数就一直在增长.想要了解为什么,以及想从你的容器中获得更多,以下主要回顾了2015年Docker容器的五大窍门. 2014年Docker复兴了容器技术,并在过去的一年里主导了整个容器市场.容器的便携性和可扩展性在云用户和开发人员那里得到了共鸣,并随着应用的增长,Docker不断地针对企业用户扩展其自身功能. 尽管竞争对手争相提供类似服务,但Docker已经成为一个家喻户晓的名字.不过,一些企业仍然不确定他们是否应该采用容器以及如何将容器集成到他们的云环			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/vbQ11Gb.html" rel="bookmark" class="title">产品部和业务部门是怎样的关系？</a>
					<div>
						&quot;我们来自于五湖四海,而且出身于不同的领域,我们各自都拥有着各自独到的技能,但是,我们是为了同一个目的走到一起,那就是为了创造出伟大的产品,而这,就是我们,这就是我们产品经理存在的意义.&q ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/2pLWKkM.html" rel="bookmark" class="title">社区&lpar;php&amp;amp&semi;&amp;amp&semi;mysql&rpar;四</a>
					<div>
						echo &quot;&lt;br&gt;&quot;;     echo &quot;&lt;TABLE width=85% border=0 cellPadding=0 cellSpacing=1 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/qbarLJM.html" rel="bookmark" class="title">共享ADSL接入方案比较</a>
					<div>
						随着ADSL的到来,很多人都努力在共享接入上下功夫.在此,笔者谈一些实际体会. 采用共享软件接入(SygateWingate) 不管系统是Win 98/NT还是2000,装两块网卡,并安装共享软件是 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MNEvAPb.html" rel="bookmark" class="title">Photoshop制作幻想世界里的美女</a>
					<div>
						在这篇Photoshop教程中,我将为大家介绍使用photoshop打造一个美女的幻想世界,希望大家喜欢!如果你细心留意教程的话,你可以会发觉,黑白风格制作出来的效果,在彩色模式下是没有的. 在pho ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/ze4Pg8p.html" rel="bookmark" class="title">Java中利用管道实现线程间的通讯</a>
					<div>
						在Java 语言中,提供了各种各样的输入输出流(stream),使我们能够很方便的对数据进行操作,其中,管道(pipe)流是一种特殊的流,用于在不同线程(threads)间直接传送数据.一个线程发送数 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zOwjQ5z.html" rel="bookmark" class="title">&period;NET3&period;5 GDI&plus;图形操作1</a>
					<div>
						前言: 本文章转载自本人刚刚买的&lt;ASP.NET 3.5从入门到精通&gt;这本书,此书介绍在 http://www.china-pub.com/44991 ,本文章95%与此书的内容完全一样, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p8j80Zb.html" rel="bookmark" class="title">Linux Kernel 4&period;5在3月15日发布最终版</a>
					<div>
						  今天Linus Torvalds和辛苦工作的内核团队非常自豪的宣布了Linux Kernel 4.5版本,并已经开放下载.自2016年1月25日首个候选版本发布,经历了长达两个多月的不懈更新,在3 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MxWEEjb.html" rel="bookmark" class="title">Win7 64位安装AutoCAD2006教程</a>
					<div>
						64位Win7能否成功安装AutoCAD2006 SP1?小编实测是成功的!64位Win7安装AutoCAD2006教程直接奉上,在Win7 32位或64位系统上安装AutoCAD2006遇到麻烦的朋 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z42XOJM.html" rel="bookmark" class="title">Windows7电脑开机出现蓝屏错误代码0x0000008E如何解决</a>
					<div>
						  故障图: 1.检查新硬件是否插牢,电脑的硬件如果没有插牢的话,就要将其稳定一下. 2.打开机箱,拿下内存条,内存插在主板上的金手指部分灰尘太多,用橡皮擦擦下金手指,然后重新拔插一下,也有可能是金手 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b24kW3p.html" rel="bookmark" class="title">win7系统telnet命令失效的解决办法</a>
					<div>
						  1.将鼠标放在桌面计算机图标上,单击鼠标右键,在弹出的菜单中点击&quot;控制面板&quot;选项,如下图所示: 2.打开控制面板后,接着点击&quot;程序和功能&quot;,如下图所示: 3 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p5oxWDb.html" rel="bookmark" class="title">WinPE小技巧一则</a>
					<div>
						  如果要为我们的WinPE增加搜索各分区根下 PETOOLS 目录文件功能,并在桌面建立快捷方式,我们有什么办法呢?下面教你一招. a)在 SYSTEM32 下增加文本文件 PETOOLS.INI, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/badORXz.html" rel="bookmark" class="title">局域网计算机怎么禁用U盘</a>
					<div>
						  1 通过修改BIOS来禁用U盘类移动存储设备的使用:开机按&quot;Del&quot;键进入BIOS界面,选择&quot;Integrated Peripherals&quot;选项,展开后将& ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zwx4Nvb.html" rel="bookmark" class="title">双十一倒计时，剧透一个作战大屏！</a>
					<div>
						已经全新上线的2016年数据作战室双11作战大屏,在双11当天,还有各种特效惊喜! 当然,熟悉生意参谋的亲应该也知道,早在去年双11,生意参谋就已经推出专属商家的作战大屏.诸如韩都衣舍.三只松鼠等TO ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bKQjW5p.html" rel="bookmark" class="title">DTCC2016部分参展商名录曝光&comma;大牌云集</a>
					<div>
						文章讲的是DTCC2016部分参展商名录曝光,大牌云集,DTCC 2016(第七届中国数据库技术大会)将于2016年5月12日-14日在北京拉开帷幕,作为国内数据库与大数据领域最大规模的技术盛宴,本届 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pPPqK1p.html" rel="bookmark" class="title">vif-求实现视频质量评价工程类方法的VIF模型的matlab代码，初学者，求帮助</a>
					<div>
						问题描述 求实现视频质量评价工程类方法的VIF模型的matlab代码,初学者,求帮助 基于视觉信息保真度的视频质量评价,求实现视频质量评价工程类方法的VIF模型的matlab代码,初学者,求帮助 解决 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pL7GY5M.html" rel="bookmark" class="title">我所理解的Remoting（1）：Marshaling &amp;amp&semi; Activation&lbrack;下篇&rsqb;</a>
					<div>
						在上面一片文章([原创]我所理解的Remoting(1):Marshaling &amp; Activation - Part I),我花了大量的文字来来描述了Remote Object如何通过Mar ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/boKdyvb.html" rel="bookmark" class="title">优先级队列</a>
					<div>
						QueueNode.h template&lt;typename Type,typename Cmp&gt; class PriorityQueue; template&lt;typename Typ ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pXqdQWz.html" rel="bookmark" class="title">mybatis-spring从1&period;1升级到1&period;2所带来的dao层级的编写问题</a>
					<div>
						我们公司的项目使用spring+mybatis组合.所以就必须得使用mybatis-spring了.所以此处就昨日mybatis-spring从1.1升级到1.2所带来的dao层级的编写问题,做了一个 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zeRWo9b.html" rel="bookmark" class="title">Hyperledger Fabric 开发环境搭建</a>
					<div>
						搭建开发环境 概述 Hyperledge fabric项目是IBM开源的区块链项目.Github地址:https://github.com/hyperledger/fabric Hyperledge  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M0R4Wmz.html" rel="bookmark" class="title">CSS3的自定义动画帧</a>
					<div>
						CSS3新增的动画帧非常绚丽,可以简单实现一些动画效果,目前除IE外各大主流浏览器都支持 本文演示三个:transform: scale3d(x, y, z)-缩放;.transform: trans ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zV0YQDM.html" rel="bookmark" class="title">grep-用shell脚本读取Hadoop集群上的文件</a>
					<div>
						问题描述 用shell脚本读取Hadoop集群上的文件 我想用grep -Ff 命令提取hadoop上两个文件中相同的内容, 例如hadoop上的文件位置为/hadoop/file1和/hadoop/ ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MAAP6ZM.html" rel="bookmark" class="title">匿名社交软件秘密：充斥大量涉及隐私和人身攻击内容</a>
					<div>
						法制晚报讯(记者 王伶玲) &quot;传说人心中有秘密的时候,就会跑到山上找一棵树,在树上挖一个洞,把秘密全说进去, 然后再用泥巴把洞封上,秘密就会永远留在那棵树里,没有人会知道.&quot;以前人 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zOmZkqM.html" rel="bookmark" class="title">微信系统故障 仍未修复</a>
					<div>
						中介交易 http://www.aliyun.com/zixun/aggregation/6858.html&quot;&gt;SEO诊断 淘宝客 云主机 技术大厅 [最科技讯]今日早晨7点半左右,微 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MNnY9PM.html" rel="bookmark" class="title">CentOS系统使用NTFS-3G挂载NTFS分区</a>
					<div>
						首先必须安装了rpmforge软件库的源 1.下载rpmforge的rpm文件包 32位系统 wget http://pkgs.repoforge.org/rpmforge-release/rpmfo ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pX0W2Lp.html" rel="bookmark" class="title">美化 Blog</a>
					<div>
						1.添加金鱼 &lt;center&gt;&lt;object classid=&quot;clsid:D27CDB6E-AE6D-11cf-96B8-444553540000&quot; codeb ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b3ZEKAz.html" rel="bookmark" class="title">非常经典的C语言趣味题目&lowbar;C 语言</a>
					<div>
						http://stevenkobes.com/ctest.html 在这个网站上发现一套很有趣的C语言测试题,如果你招聘C语言相关开发人员,或者正在学习C语言,很值得做一做. 如果没有做,下面内容暂时 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/boL0NEM.html" rel="bookmark" class="title">C语言new操作的安全性分析&lowbar;C 语言</a>
					<div>
						对于学习过C语言的朋友应该都知道,使用 malloc/calloc 等分配内存的函数时,一定要检查其返回值是否为&quot;空指针&quot;(亦即检查分配内存的操作是否成功),这是良好的编程习惯,也 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b3ZxJmz.html" rel="bookmark" class="title">hiebrnate的查询</a>
					<div>
						问题描述 我在class类中有个student类,在取值时可以取到action中,但是到jsp中我用el表达式${list.student.name}就取不出来.请问这是什么问题? 解决方案 解决方案 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pLBAJ5b.html" rel="bookmark" class="title">《Nmap渗透测试指南》&mdash;第10章10&period;8节编辑扫描模板</a>
					<div>
						10.8 编辑扫描模板如图10.21所示,Zenmap有很多自定义模板,我们可以对其中现有的模板进行编辑.点击Profile菜单选择&quot;Edit Selected Profile&quot;. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MWd8Kmp.html" rel="bookmark" class="title">美邦周成建自称像暴君原副总裁转投波司登</a>
					<div>
						最近几天,在美邦服饰原副总裁程伟雄的微博上,频频出现&quot;波司登不仅仅只是羽绒服&quot;的口号,这喻示着他已经有了新战场.对于另拓非羽绒服业务的波司登来说,招揽到这样一位有故事有经验的人物是 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 12 q. 0.032 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
